@echo off

set ext_name=%1
if not "%ext_name%"==".rtf" if not "%ext_name%"==".docx" if not "%ext_name%"==".dotx" if not "%ext_name%"==".odt" if not "%ext_name%"==".xlsx" if not "%ext_name%"==".xltx" if not "%ext_name%"==".pptx" exit

set "OPAppFile="
set "OPAppName="
set "OPDefaultAppName="

if "%ext_name%"==".rtf" (
	set OPAppFile=OP-Document.bat
	set OPAppName=OPTEShell
	set OPDefaultAppName=rtffile
)

if "%ext_name%"==".docx" (
	set OPAppFile=OP-Document.bat
	set OPAppName=OPTEShell
	set OPDefaultAppName=docxfile
)

if "%ext_name%"==".dotx" (
	set OPAppFile=OP-Document.bat
	set OPAppName=OPTEShell
)

if "%ext_name%"==".odt" (
	set OPAppFile=OP-Document.bat
	set OPAppName=OPTEShell
	set OPDefaultAppName=odtfile
)

if "%ext_name%"==".ott" (
	set OPAppFile=OP-Document.bat
	set OPAppName=OPTEShell
)

if "%ext_name%"==".xlsx" (
	set OPAppFile=OP-Tables.bat
	set OPAppName=OPETShell
)

if "%ext_name%"==".xltx" (
	set OPAppFile=OP-Tables.bat
	set OPAppName=OPETShell
)

if "%ext_name%"==".ods" (
	set OPAppFile=OP-Tables.bat
	set OPAppName=OPETShell
)

if "%ext_name%"==".ots" (
	set OPAppFile=OP-Tables.bat
	set OPAppName=OPETShell
)

if "%ext_name%"==".pptx" (
	set OPAppFile=OP-Presentation.bat
	set OPAppName=OPPEShell
)

if "%ext_name%"==".odp" (
	set OPAppFile=OP-Presentation.bat
	set OPAppName=OPPEShell
)

rem deleting current user settings
reg add HKCU\emptyKey /f
reg save HKCU\emptyKey empty.hiv /y
reg delete HKCU\emptyKey /f
reg restore HKCU\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\%ext_name% empty.hiv
del empty.hiv

rem adding OpenWithProgids
echo Windows Registry Editor Version 5.00 > none.reg
echo [HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\%ext_name%\OpenWithProgids] >> none.reg
echo "%OPAppName%"=hex(0): >> none.reg
if not "%OPDefaultAppName%"=="" echo "%OPDefaultAppName%"=hex(0): >> none.reg
reg import none.reg
del /q none.reg

rem adding OpenWithList
reg add HKCU\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\%ext_name%\OpenWithList /v a /d %OPAppFile%
reg add HKCU\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\%ext_name%\OpenWithList /v MRUList /d a

ie4uinit.exe -ClearIconCache -show

exit