#!/bin/bash

CURRENT_DIR=$(dirname "$0")
pushd "$CURRENT_DIR" > /dev/null
source .common.sh
popd > /dev/null

WORKING_DIR="$CURRENT_DIR/.."
SCRIPT_NAME=$(basename "$0" ".sh")
CONFIG_PROPERTIES="bin/$SCRIPT_NAME.properties"
STARTER_CONTEXT=$*

run_java_service_application "$WORKING_DIR" "$CONFIG_PROPERTIES" "${STARTER_CONTEXT[@]}"